Subject: Re: Kernel Preemption patch

From: Todd Poynor <[email-masked]>
Date: Mon, 24 Feb 2003 11:06:39 -0800

At 07:56 AM 2/24/2003, [email-masked] wrote:

> However, I noticed that your 'preempt_enable' at the bottom of the
> exerp has
> been changed from 'preempt_enable' as in the RML patch, to
> 'preempt_enable_no_reshed'. What's the reason for this inconsistency?

The preempt_enable_no_reshed avoids a kernel stack overflow seen in
certain cases of heavy preemption, where each nested call to reschedule
on preemption is interrupted and again requests a preemption.  The
proper place to check for another preemption is at the top-level
interrupt/exception handler, so that we iterate and not recurse.

Oops, MontaVista needs to contribute this bug fix back to RML's public
patch, I'll put it on my list.

--
Todd

** Sent via the linuxppc-embedded mail list. See http://lists.linuxppc.org/